
#%%
def shift(c, k):
    # get the number of character c in Unicode table
    idx = ord(c)

    # shift index to right (and wrap around)
    rotated_idx = (idx+k)%0x10fff

    # get character at shifted position
    return chr(rotated_idx)

def caesar_encrypt(plain: str, key: int) -> str:
    cipher = []
    for c in plain:
        cipher.append(shift(c, key))
    return ''.join(cipher)

def caesar_decrypt(cipher: str, key: int) -> str:
    plain = []
    for c in cipher:
        plain.append(shift(c, -key))
    return ''.join(plain)


#%% We can use ord and chr to map characters to their index in the Unicode table and back
print(ord('a'))
print(chr(97))

#%% Alice and Bob share secret key 
secret_key = 5453

# Alice encrypts message and send it to Bob
cipher = caesar_encrypt('Hello World!', secret_key)
print('Alice sends: \t', cipher)

# Bob receives cipher and uses key to decrypt it
plain = caesar_decrypt(cipher, secret_key)
print('Bob decrypts: \t', plain)

# %% Carol performs a brute force attack
print('Carol intercepts', cipher)
for k in range(0x10fff):
    p = caesar_decrypt(cipher, k)
    if p == 'Hello World!':
        print('Carol found secret key', k)


# %%
