#%%
import string 
import random
from itertools import permutations

def substitution_encrypt(plain: str, key: dict) -> str:
    cipher = []
    for c in plain:
        cipher.append(key[c])
    return ''.join(cipher)

def substitution_decrypt(cipher: str, key: dict) -> str:
    reverse = { v: k for (k, v) in key.items()}
    plain = []
    for c in cipher:
        plain.append(reverse[c])
    return ''.join(plain)

alphabet = list(string.ascii_lowercase)
alphabet.append(' ')

#%% Alice and Bob share (randomly generated) secret key 
permutation = alphabet.copy() 
random.shuffle(permutation)
secret_key = { alphabet[i]: permutation[i] for i in range(len(alphabet))}
print(secret_key)

#%%
# Alice encrypts message and send it to Bob
cipher = substitution_encrypt('hello world', secret_key)
print('Alice sends: \t', cipher)

# Bob receives cipher and uses key to decrypt it
plain = substitution_decrypt(cipher, secret_key)
print('Bob decrypts: \t', plain)

# %% Carol performs a brute force attack
print('Carol intercepts', cipher)
i = 1

for k in permutations(alphabet):
    key = { alphabet[i]: k[i] for i in range(len(alphabet))}
    p = substitution_decrypt(cipher, key)    
    if p == 'hello world':
        print('Carol found secret key', k)
    else:
        if i % 100000 ==0:
            print('Tested keys', i)
    i = i+1

