#%% 

# In NTFS, small files are stored within the Master File Table 

# We can test this by creating a file with 500 bytes. The size on disk shown in the Windows file properties is zero because this is a resident file that is directly stored within the MFT
f = open('test_resident.txt', 'w')

data = ""
size = 500
for i in range(size):
    data += 'x'

f.write(data)

f.close()

# %%
# If we add 400 more bytes, the file will not be able to fit within the 1 kB inode of the MFT, so the data becomes non-resident and the file now minimally occupies one full block (here 4 KiB)
f = open('test_resident.txt', 'a')

data = ""
size = 400
for i in range(size):
    data += 'x'

f.write(data)

f.close()


# %%
# We overwrite the file with 500 bytes of data 
f = open('test_resident.txt', 'w')

data = ""
size = 500
for i in range(size):
    data += 'x'

f.write(data)

f.close()
# %%
